<h1>New order</h1>

<mat-horizontal-stepper linear="true" #stepper>
  <mat-step>
    <ng-template matStepLabel>Select service</ng-template>
    <div class="searchbar">
      <mat-form-field class="search" appearance="fill">
        <mat-label>Search workflows</mat-label>
        <input
          matInput
          type="text"
          [(ngModel)]="search"
          (keyup.enter)="loadWorkflows()"
        />
        <button
          *ngIf="search"
          matSuffix
          mat-icon-button
          aria-label="Clear"
          (click)="search = ''; loadWorkflows()"
        >
          <mat-icon>close</mat-icon>
        </button>
        <button *ngIf="!search" matSuffix mat-icon-button>
          <mat-icon>search</mat-icon>
        </button>
      </mat-form-field>
    </div>
    <div class="services">
      <div class="service" *ngFor="let service of services">
        <button mat-raised-button (click)="selectService(service)">
          <span class="service-details">
            <span class="service-title">
              <i class="material-icons" *ngIf="service.icon">
                {{ service.icon }}
              </i>
              {{ service.label }}

              <span class="version">
                (latest v{{ service.version_major }}.{{
                  service.version_minor
                }}.{{ service.version_micro }})
              </span>
              <span *ngIf="service.is_live" class="badge-live"> LIVE </span>
            </span>

            <span class="tags">
              <mat-chip-list class="tag" *ngFor="let tag of service.tags">
                <mat-chip color="white" selected>
                  {{ tag }}
                </mat-chip>
              </mat-chip-list>
            </span>
          </span>
        </button>
      </div>
    </div>
    <mat-toolbar>
      <mat-toolbar-row>
        <button mat-raised-button color="primary" (click)="loadWorkflows()">
          <span class="material-icons"> refresh </span>
        </button>
        <mat-paginator
          class="paginator"
          showFirstLastButtons="true"
          [length]="serviceLength"
          [pageSize]="pageSize"
          [pageIndex]="page"
          [pageSizeOptions]="pageSizeOptions"
          (page)="pageEvent = eventGetWorkflows($event)"
          *ngIf="services && services.length > 0"
        >
        </mat-paginator>
      </mat-toolbar-row>
    </mat-toolbar>
  </mat-step>
  <mat-step optional="false">
    <ng-template matStepLabel>Select service version</ng-template>
    <div class="services">
      <div class="service" *ngFor="let service of selectedServiceVersion">
        <button mat-raised-button (click)="selectVersion(service)">
          <i class="material-icons" *ngIf="service.icon">
            {{ service.icon }}
          </i>
          {{ service.label }}
          <span class="version">
            v{{ service.version_major }}.{{ service.version_minor }}.{{
              service.version_micro
            }}
          </span>
          <span *ngIf="service.is_live" class="badge-live"> LIVE </span>
        </button>
      </div>
    </div>
    <mat-paginator
      class="paginator"
      showFirstLastButtons="true"
      [length]="versionLength"
      [pageSize]="pageSize"
      [pageIndex]="page"
      [pageSizeOptions]="pageSizeOptions"
      (page)="pageEvent = eventGetWorkflows($event)"
      *ngIf="services && services.length > 0"
    >
    </mat-paginator>
  </mat-step>
  <mat-step>
    <ng-template matStepLabel>Configuration</ng-template>
    <div *ngIf="selectedService">
      <div
        class="service"
        *ngFor="let parameter of selectedService.start_parameters"
      >
        <div class="dropzone" *ngIf="parameter.type == 'file'">
          <mat-form-field>
            <ngx-mat-file-input
              [(ngModel)]="parameters[parameter.id]"
              [placeholder]="parameter.label"
              [accept]="parameter.accept"
            >
            </ngx-mat-file-input>
            <mat-icon ngxMatFileInputIcon>folder</mat-icon>
          </mat-form-field>
        </div>
        <mat-form-field *ngIf="parameter.type == 'choice'">
          <mat-select
            [placeholder]="parameter.label"
            [(ngModel)]="parameters[parameter.id]"
          >
            <mat-option
              *ngFor="let item of parameter.items"
              [value]="item.id"
              [ngClass]="item.id"
            >
              {{ item.label }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field *ngIf="parameter.type == 'string'">
          <input
            matInput
            [placeholder]="parameter.label"
            [value]="getDefaultParameterValue(parameter)"
            (input)="parameterChange(parameter.id, $event)"
          />
        </mat-form-field>
        <mat-form-field *ngIf="parameter.type == 'number'">
          <input
            matInput
            [placeholder]="parameter.label"
            type="number"
            [value]="getDefaultParameterValue(parameter)"
            (input)="parameterChange(parameter.id, $event)"
            [step]="parameter.step ? parameter.step : 1"
          />
          <mat-icon matSuffix>{{ parameter.icon }}</mat-icon>
        </mat-form-field>
      </div>
    </div>
    <div>
      <button mat-button matStepperPrevious>Previous</button>
      <button mat-button matStepperNext (click)="upload()">Next</button>
    </div>
  </mat-step>

  <mat-step [stepControl]="upload">
    <ng-template matStepLabel>File upload</ng-template>
    <div>Files uploaded:</div>

    <div *ngFor="let progressBar of progressBars" class="fileProgress">
      {{ progressBar.name }} -
      {{ progressBar.progress | number : '1.0-0' }}&nbsp;%
      <mat-progress-bar [value]="progressBar.progress"> </mat-progress-bar>
    </div>

    <div>
      <button mat-button matStepperPrevious>Previous</button>
      <button
        mat-button
        matStepperNext
        [disabled]="!uploadCompleted"
        (click)="startWorkflow()"
      >
        Start order
      </button>
    </div>
  </mat-step>
  <mat-step [stepControl]="startWorkflow">
    <ng-template matStepLabel>Processing</ng-template>
    <div [ngStyle]="{ color: processStatus.failed ? 'red' : 'black' }">
      {{ processStatus.message }}
    </div>

    <button mat-button (click)="follow()">
      {{ processStatus.failed ? 'Previous' : 'Follow order' }}
    </button>
  </mat-step>
</mat-horizontal-stepper>
